#define SAVE_SCREEN     // restore screen after program end
#define USE_GRAY_PATCH  // use grayscale patch
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#include <tigcclib.h>   // necessary for the nostub stuff
#include "fatdata.h"		//Include all graphics data

int _ti92plus;          // needed to produce ti92+ code
unsigned char len,val;
unsigned char *source;
unsigned char *pic1;
unsigned char *pic2;
unsigned char *dest;
unsigned int size;
unsigned int i;
short y;

/*===========================================================================*/
/* decompresses RLE-encoded background to LCD memory                         */
/*===========================================================================*/
void RLE_Decompression(void) {
 if (!GrayOn ()) return;
 for (i=0;i<2;i++) {
 if (i==0) { source = pic1; dest = (unsigned char*)GetPlane(0);}
 else { source = pic2; dest = (unsigned char*)GetPlane(1);}
 size = 3840; // 240*128/8
 while (size) {
 if (*source == 0x91) { source++; val = *source++; len = *source++;
 while (len) { *dest++ = val; len--; size--;}
 }
 else { *dest++ = *source++; size--; }
 }
 }
}

void Picture(void) {
 RLE_Decompression();
 GrayOff();}
 
void Picture_1(void) {
 pic1 = Cartman1;
 pic2 = Cartman2;
 Picture();}

void Picture_2(void) {
 pic1 = Cartman3;
 pic2 = Cartman4;
 Picture();}

void _main(void) {
 for(y=0;y<50;y++) {
 Picture_1();
 Picture_2();}
 GrayOff();
 return;}

//Uncompressed 4 level grayscale (2 frames) is 7680 bytes, for full screen.